package com.cool.store.utils.poi;

import cn.hutool.core.date.DateUtil;
import com.cool.store.utils.CoolDateUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.jetbrains.annotations.NotNull;

import java.lang.management.ManagementFactory;
import java.text.ParseException;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.temporal.TemporalAdjusters;
import java.util.Date;

/**
 * 时间工具类
 *
 * @author fanlyun
 */
@Slf4j
public class DateUtils extends org.apache.commons.lang3.time.DateUtils {
    public static String YYYY = "yyyy";

    public static String YYYY_MM = "yyyy-MM";

    public static String YYYY_MM_DD = "yyyy-MM-dd";

    public static String YYYYMMDDHHMMSS = "yyyyMMddHHmmss";

    public static String YYYY_MM_DD_HH_MM_SS = "yyyy-MM-dd HH:mm:ss";

    public static String SPECIAL_DATE_START = "yyyy年MM月dd日 HH:mm";

    public static String SPECIAL_DATE_START_1 = "yyyy年MM月dd日";

    public static String SPECIAL_DATE_START_2 = "dd日";

    public static String SPECIAL_DATE_END = "HH:mm";

    private static String[] parsePatterns = {
            "yyyy-MM-dd", "yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd HH:mm", "yyyy-MM",
            "yyyy/MM/dd", "yyyy/MM/dd HH:mm:ss", "yyyy/MM/dd HH:mm", "yyyy/MM",
            "yyyy.MM.dd", "yyyy.MM.dd HH:mm:ss", "yyyy.MM.dd HH:mm", "yyyy.MM"};

    /**
     * 获取当前Date型日期
     *
     * @return Date() 当前日期
     */
    public static Date getNowDate() {
        return new Date();
    }

    /**
     * 获取当前日期, 默认格式为yyyy-MM-dd
     *
     * @return String
     */
    public static String getDate() {
        return dateTimeNow(YYYY_MM_DD);
    }

    public static String getTime() {
        return dateTimeNow(YYYY_MM_DD_HH_MM_SS);
    }

    public static String dateTimeNow() {
        return dateTimeNow(YYYYMMDDHHMMSS);
    }

    public static String dateTimeNow(final String format) {
        return parseDateToStr(format, new Date());
    }

    public static String dateTime(final Date date) {
        return parseDateToStr(YYYY_MM_DD, date);
    }


    /**
     * 格式化日期
     *
     * @param format 格式化规则
     * @param date   日期
     * @return 格式化完毕的日期
     */
    public static String parseDateToStr(final String format, final Date date) {
        if(StringUtils.isEmpty(format)|| ObjectUtils.isEmpty(date)){
            return null;
        }
        return new SimpleDateFormat(format).format(date);
    }

    /**
     * 以规则解析时间字符串
     *
     * @param format 格式化规则
     * @param ts     时间字符串
     * @return 解析后时间
     */
    public static Date dateTime(final String format, final String ts) {
        try {
            return new SimpleDateFormat(format).parse(ts);
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * 日期路径 即年/月/日 如2018/08/08
     */
    public static String datePath() {
        Date now = new Date();
        return DateFormatUtils.format(now, "yyyy/MM/dd");
    }

    /**
     * 日期路径 即年/月/日 如20180808
     */
    public static String dateTime() {
        Date now = new Date();
        return DateFormatUtils.format(now, "yyyyMMdd");
    }

    /**
     * 日期型字符串转化为日期 格式
     */
    public static Date parseDate(Object str) {
        if (str == null) {
            return null;
        }
        try {
            return parseDate(str.toString(), parsePatterns);
        } catch (ParseException e) {
            return null;
        }
    }

    /**
     * 获取服务器启动时间
     */
    public static Date getServerStartDate() {
        long time = ManagementFactory.getRuntimeMXBean().getStartTime();
        return new Date(time);
    }

    /**
     * 计算两个时间差
     */
    public static String getDatePoor(Date endDate, Date nowDate) {
        long nd = 1000 * 24 * 60 * 60;
        long nh = 1000 * 60 * 60;
        long nm = 1000 * 60;
        // long ns = 1000;
        // 获得两个时间的毫秒时间差异
        long diff = endDate.getTime() - nowDate.getTime();
        // 计算差多少天
        long day = diff / nd;
        // 计算差多少小时
        long hour = diff % nd / nh;
        // 计算差多少分钟
        long min = diff % nd % nh / nm;
        // 计算差多少秒//输出结果
        // long sec = diff % nd % nh % nm / ns;
        return day + "天" + hour + "小时" + min + "分钟";
    }

    /**
     * 以规则解析时间字符串
     *
     * @param strDate 时间字符串
     * @param pattern 格式化规则
     * @return 解析后时间
     */
    public static Date strToDate(String strDate, String pattern) {
        SimpleDateFormat formatter = new SimpleDateFormat(pattern);
        ParsePosition pos = new ParsePosition(0);
        return formatter.parse(strDate, pos);
    }

    /**
     * 根据毫秒数获取时间
     *
     * @param millis 毫秒数
     * @return 时间
     */
    public static String getDateByMillis(long millis) {
        //12小时制
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat(YYYY_MM_DD_HH_MM_SS);
        Date date = new Date();
        date.setTime(millis);
        return simpleDateFormat.format(date);
    }


    public static String YYYY_MM_DD_HH_MM = "yyyy-MM-dd HH:mm";
    public static String NOTICE_DATE = "yyyy年MM月dd日 HH:mm";

    /**
     * 返回11个月之前的月，从月的第一天开始，如当前是2020-05-03 返回的是2019-06-01 00:00:00
     *
     * @return Date
     */
    public static Date getNestOneYear() {
        LocalDate minusDays = LocalDate.now().minusMonths(11).with(TemporalAdjusters.firstDayOfMonth());
        return fromDate(minusDays);
    }

    /**
     * 从1.8新增的{@link LocalDate}转换为{@link Date}
     *
     * @param localDate {@link LocalDate}
     * @return 时间
     */
    private static Date fromDate(LocalDate localDate) {
        ZoneId zone = ZoneId.systemDefault();
        Instant instant = localDate.atStartOfDay().atZone(zone).toInstant();
        return Date.from(instant);
    }

    public static String parseLongDateToStr(final Long time) {
        if (time == null) {
            return null;
        }
        return new SimpleDateFormat(YYYY_MM_DD_HH_MM_SS).format(new Date(time));
    }
    /**
     *
     * @Date: 2024/5/11
     * @description:获取X天后的时间 LocalDate
     */
    public static  LocalDate getPlusFDays(Date date, Integer days) {
        Instant instant = date.toInstant();
        ZoneId zone = ZoneId.systemDefault();
        LocalDate localDate = instant.atZone(zone).toLocalDate();
        LocalDate datePlusFDays = localDate.plusDays(days);
        return datePlusFDays;

    }
}
